<template>
  <div class="tenant">
    <!-- <Banner /> -->
    <div class="content">
      <byTable
        :source="sourceList.data"
        :pagination="sourceList.pagination"
        :config="config"
        :loading="loading"
        highlight-current-row
        :selectConfig="selectConfig"
        :table-events="{
          //element talbe事件都能传
          select: select,
        }"
        :action-list="[
          {
            text: '添加物流数据',
            action: () => openModal('add'),
          },
        ]"
        @get-list="getList"
      >
        <template #one="{ item }">
          <div style="cursor: pointer; color: #409eff">
            {{ item.businessCode }}
          </div>
        </template>
        <template #two="{ item }">
          <div
            style="cursor: pointer; color: #409eff"
            @click="handleClickCode(item)"
          >
            {{ item.code }}
          </div>
        </template>
      </byTable>
    </div>
    <el-dialog
      :title="modalType == 'add' ? '添加物流数据' : '调仓接收'"
      v-model="dialogVisible"
      width="800"
      v-loading="loading"
    >
      <byForm
        :formConfig="formConfig"
        :formOption="formOption"
        v-model="formData.data"
        :rules="rules"
        ref="byform"
      >
        <template #products>
          <div style="width: 100%">
            <el-button
              type="primary"
              @click="openProduct = true"
              style="margin-bottom: 10px"
            >
              添加物品
            </el-button>
            <el-table :data="formData.data.stockWaitDetailsList">
              <el-table-column prop="name" label="物品编码" />
              <el-table-column prop="name" label="物品名称" />
              <el-table-column prop="name" label="规格型号" />
              <el-table-column
                prop="name"
                label="调仓数量"
                v-if="modalType == 'edit'"
              />
              <el-table-column
                prop="quantity"
                label="调仓数量"
                min-width="150"
                v-if="modalType == 'add'"
              >
                <template #default="{ row, $index }">
                  <el-form-item
                    :prop="'stockWaitDetailsList.' + $index + '.quantity'"
                    :rules="rules.quantity"
                    :inline-message="true"
                  >
                    <el-input-number
                      v-model="row.quantity"
                      :precision="4"
                      :controls="false"
                      :min="0"
                    />
                  </el-form-item>
                </template>
              </el-table-column>
              <el-table-column
                prop="quantity"
                label="接收数量"
                min-width="150"
                v-if="modalType == 'edit'"
              >
                <template #default="{ row, $index }">
                  <el-form-item
                    :prop="'stockWaitDetailsList.' + $index + '.quantity'"
                    :rules="rules.quantity"
                    :inline-message="true"
                  >
                    <el-input-number
                      v-model="row.quantity"
                      :precision="4"
                      :controls="false"
                      :min="0"
                    />
                  </el-form-item>
                </template>
              </el-table-column>

              <el-table-column prop="zip" label="操作" width="100">
                <template #default="{ $index }">
                  <el-button type="primary" link @click="handleRemove($index)"
                    >删除</el-button
                  >
                </template>
              </el-table-column>
            </el-table>
          </div>
        </template>
      </byForm>
      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button
          type="primary"
          @click="submitForm('byform')"
          size="large"
          :loading="submitLoading"
        >
          确 定
        </el-button>
      </template>
    </el-dialog>
    <el-dialog
      v-model="openProduct"
      title="选择产品"
      width="70%"
      append-to-body
    >
      <SelectProduct @handleSelect="handleSelect"></SelectProduct>
      <template #footer>
        <span class="dialog-footer">
          <el-button @click="openProduct = false">取消</el-button>
        </span>
      </template>
    </el-dialog>

    <el-dialog title="物流数据" v-model="openRecord" width="40%" top="50px">
      <!-- <div style="padding-left: 40px; margin-bottom: 20px">
        <el-button size="mini" @click="handleAddRecord">
          添加物流记录
        </el-button>
      </div> -->
      <div>
        <el-timeline :reverse="false">
          <el-timeline-item
            placement="top"
            v-for="(activity, index) in activities"
            :key="index"
            :timestamp="activity.ftime"
          >
            {{ activity.context }}
          </el-timeline-item>
        </el-timeline>
      </div>
    </el-dialog>
  </div>
</template>
  
<script setup>
/* eslint-disable vue/no-unused-components */
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import { computed, defineComponent, ref } from "vue";
import useUserStore from "@/store/modules/user";
import SelectProduct from "@/components/WDLY/product/SelectProduct";

const loading = ref(false);
const submitLoading = ref(false);
const sourceList = ref({
  data: [],
  pagination: {
    total: 3,
    pageNum: 1,
    pageSize: 10,
  },
});
let dialogVisible = ref(false);
let openProduct = ref(false);
let openRecord = ref(false);
const activities = ref([]);

let roomDialogVisible = ref(false);
let modalType = ref("add");
let rules = ref({
  businessType: [
    { required: true, message: "请选择数据来源", trigger: "change" },
  ],
  logisticsCompanyCode: [
    { required: true, message: "请选择物流/快递公司", trigger: "change" },
  ],
  code: [{ required: true, message: "请输入物流/快递单号", trigger: "blur" }],
  isKd100: [{ required: true, message: "请选择是否同步", trigger: "change" }],
});
const { proxy } = getCurrentInstance();
const selectConfig = reactive([
  {
    label: "数据来源",
    prop: "businessType",
    data: [],
  },
  {
    label: "物流状态",
    prop: "logisticsStatus",
    data: [],
  },
  {
    label: "完成状态",
    prop: "status",
    data: [
      {
        label: "待接收",
        value: "1",
      },
      {
        label: "部分接收",
        value: "2",
      },
      {
        label: "已接收",
        value: "2",
      },
    ],
  },
]);

const config = computed(() => {
  return [
    {
      attrs: {
        label: "数据来源",
        prop: "businessType",
      },
      render(type) {
        return proxy.dictDataEcho(type, businessType.value);
      },
    },
    {
      attrs: {
        label: "关联单号",
        prop: "businessCode",
        slot: "one",
      },
    },
    {
      attrs: {
        label: "物流/快递公司",
        prop: "logisticsCompanyCode",
      },
    },
    {
      attrs: {
        label: "物流/快递单号",
        prop: "code",
        slot: "two",
      },
    },
    {
      attrs: {
        label: "物流状态",
        prop: "logisticsStatus",
      },
    },
    {
      attrs: {
        label: "创建时间",
        prop: "createTime",
      },
    },

    {
      attrs: {
        label: "操作",
        width: "200",
        align: "right",
      },
      // 渲染 el-button，一般用在最后一列。
      renderHTML(row) {
        return [
          {
            attrs: {
              label: "修改",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              getDtl(row);
            },
          },
          {
            attrs: {
              label: "更新状态",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              getDtl(row);
            },
          },
          {
            attrs: {
              label: "到货通知",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              getDtl(row);
            },
          },
        ];
      },
    },
  ];
});

let formData = reactive({
  data: {},
  treeData: [],
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const byform = ref(null);
const treeData = ref([]);
const formConfig = reactive([
  {
    type: "select",
    prop: "businessType",
    label: "数据来源",
    data: [],
    itemWidth: 61,
  },
  {
    type: "select",
    prop: "logisticsCompanyCode",
    label: "物流/快递信息",
    data: [],
    itemWidth: 40,
    style: {
      width: "100%",
    },
  },
  {
    type: "input",
    prop: "code",
    label: " ",
    itemWidth: 60,
  },
  {
    type: "radio",
    prop: "isKd100",
    label: "是否同步",
    required: true,
    border: true,
    data: [
      { label: "是", value: "1" },
      { label: "否", value: "2" },
    ],
  },
  {
    type: "input",
    prop: "remark",
    label: "备注",
    itemType: "textarea",
  },
]);
const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy
    .post("/logisticsInfos/page", sourceList.value.pagination)
    .then((message) => {
      console.log(message);
      sourceList.value.data = message.rows;
      sourceList.value.pagination.total = message.total;
      setTimeout(() => {
        loading.value = false;
      }, 200);
    });
};
const openModal = () => {
  dialogVisible.value = true;
  modalType.value = "add";
  formData.data = {
    isKd100: "1",
  };
};

const submitForm = () => {
  console.log(byform.value);
  byform.value.handleSubmit((valid) => {
    submitLoading.value = true;
    proxy.post("/logisticsInfos/" + modalType.value, formData.data).then(
      (res) => {
        ElMessage({
          message: modalType.value == "add" ? "添加成功" : "编辑成功",
          type: "success",
        });
        dialogVisible.value = false;
        submitLoading.value = false;
        getList();
      },
      (err) => (submitLoading.value = false)
    );
  });
};

const getDtl = (row) => {
  modalType.value = "edit";
  proxy.post("/productSpu/detail", { id: row.id }).then((res) => {
    res.stockWaitDetailsList = res.productInfoList;
    formData.data = res;
    dialogVisible.value = true;
  });
};

const warehouseList = ref([]);
const warehouseListData = () => {
  // // 币种数据
  proxy
    .post("/warehouse/page", {
      pageNum: 1,
      pageSize: 10,
    })
    .then((message) => {
      warehouseList.value = message.rows;
      formConfig[1].data = message.rows.map((x) => ({
        label: x.name,
        value: x.id,
      }));
      formConfig[2].data = message.rows.map((x) => ({
        label: x.name,
        value: x.id,
      }));
      selectConfig[0].data = message.rows.map((x) => ({
        label: x.name,
        value: x.id,
      }));
      selectConfig[1].data = message.rows.map((x) => ({
        label: x.name,
        value: x.id,
      }));
    });
};

const logisticsData = ref([]);
const getLogisticsData = (row) => {
  proxy.post("/companyInfo/list", { pageNum: 1, pageSize: 999 }).then((res) => {
    logisticsData.value = res.reverse().slice(0, 100); //截取前100
    formConfig[1].data = logisticsData.value.map((x) => ({
      label: x.name,
      value: x.code,
    }));
  });
};

getList();
getLogisticsData();

const handleSelect = (row) => {
  const flag = formData.data.stockWaitDetailsList.some((x) => x.id === row.id);
  if (flag)
    return ElMessage({
      message: "该物品已选择",
      type: "info",
    });
  formData.data.stockWaitDetailsList.push({
    name: row.name,
    code: row.code,
    id: row.id,
  });
  return ElMessage({
    message: "选择成功",
    type: "success",
  });
};

const handleRemove = (index) => {
  formData.data.stockWaitDetailsList.splice(index, 1);
  return ElMessage({
    message: "删除成功",
    type: "success",
  });
};

const handleClickCode = (row) => {
  ElMessage({
    message: "数据请求中，请稍后！",
    type: "success",
  });
  let id = row.id;
  proxy.post("/logisticsInfos/getLogistics", { id }).then((res) => {
    console.log(res, "wss");
  });
  openRecord.value = true;
};

const businessType = ref([
  {
    dictValue: "采购入库",
    dictKey: "1",
  },
  {
    dictValue: "京东订单出库",
    dictKey: "2",
  },
  {
    dictValue: "销售订单出库",
    dictKey: "3",
  },
  {
    dictValue: "京东退货",
    dictKey: "4",
  },
]);

onMounted(() => {
  selectConfig[0].data = businessType.value.map((x) => ({
    label: x.dictValue,
    value: x.dictKey,
  }));
  formConfig[0].data = businessType.value.map((x) => ({
    label: x.dictValue,
    value: x.dictKey,
  }));
});
</script>
  
<style lang="scss" scoped>
.tenant {
  padding: 20px;
}
</style>